# -*- coding: utf-8 -*-
#################################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2012 Julius Network Solutions SARL <contact@julius.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#################################################################################

from osv import fields, osv
from tools.translate import _

class hr_employee(osv.osv):
    _inherit = 'hr.employee'
    
    _defaults = {
        'product_id': lambda *a: False,
    }
    
    def _create_employee_product(self, cr, uid, employee_id, context=None):
        if context == None:
            context = {}
        product_id = False
        employee = self.pool.get('hr.employee').browse(cr, uid, employee_id, context=context)
        md = self.pool.get('ir.model.data')
        uom_id = md.get_object_reference(cr, uid, 'product', 'uom_hour')
        category_id = md.get_object_reference(cr, uid, 'hr_employee_product_auto', 'product_employee')
        categ = self.pool.get('product.category').browse(cr, uid, category_id[1], context=context)
        taxes_id = [x.id for x in categ.sale_taxes_ids]
        supplier_taxes_id = [x.id for x in categ.purchase_taxes_ids]
        name = employee.name or ''
        first = employee.first_name or ''
        name = first and name and first + ' ' + name or name
        if not name:
            name = first
        vals = {
            'name': name,
            'uom_id': uom_id[1],
            'uom_po_id': uom_id[1],
            'categ_id': category_id[1],
            'taxes_id': [(6,0, taxes_id)],
            'supplier_taxes_id': [(6,0, supplier_taxes_id)],
            'type': 'service',
            'procure_method': 'make_to_stock',
            'supply_method': 'buy',
            'standard_price': 1,
            'list_price': 1,
        }
        product_id = self.pool.get('product.product').create(cr, uid, vals, context=context)
        return product_id
    
    def create_employee_product(self, cr, uid, ids, context=None):
#        employee_ids = self.search(cr, uid, [('product_id','=',False),('active', 'in', [True,False])])
        for employee in self.browse(cr, uid, ids, context=context):
            if not employee.product_id:
                product_id = self._create_employee_product(cr, uid, employee.id, context=context)
                if product_id:
                    self.pool.get('hr.employee').write(cr, uid, employee.id, {'product_id': product_id}, context=context)
        return True
    
hr_employee()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: