# -*- coding: utf-8 -*-
#################################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 Julius Network Solutions SARL <contact@julius.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#################################################################################

from osv import fields, osv
from tools.translate import _

class hr_contract(osv.osv):

    _inherit = "hr.contract"
    _columns = {
        'overtime1': fields.float('Hours limit no overtime', help="This is the limit of hours worked by week, if the employee works more than this limit this will leads to overtime type 1"),
        'overtime2': fields.float('Hours limit overtime type 1', help="This is the limit of overtime hours worked by week type 1, if the employee works more than this limit this will leads to overtime type 2"),
    }
    
    _defaults = {
        'overtime2': 8,
    }

hr_contract()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
