# -*- coding: utf-8 -*-
#################################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2012 Julius Network Solutions SARL <contact@julius.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#################################################################################

import time
from datetime import timedelta
from dateutil.relativedelta import relativedelta
import datetime
from mx import DateTime
from osv import fields, osv
from tools.translate import _

#class service_period(osv.osv):
#    _description='Period'
#    _name = "service.period"
#
#    def _name_user(self, cr, uid, ids, field_name, arg, context={}):
#        res = {}
#        records = self.browse(cr, uid, ids, context)
#        for record in records :
#            name = ''
#            res[record.id] = {
#                'name' : '',
#            }
#            if record.month:
#                if len(record.month) > 1:
#                    name = record.month
#                else:
#                    name = '0' + record.month
#            if record.year:
#                name += '/' + record.year
#            res[record.id]['name'] += name
#        return res
#
#    def _get_date(self, cr, uid, ids, field_name, arg, context={}):
#        res = {}
#        records = self.browse(cr, uid, ids, context)
#        for record in records :
#            res[record.id] = {
#                'year' : False,
#                'month' : False,
#            }
#            if record.date_end:
#                date_end = datetime.datetime.strptime(record.date_end, "%Y-%m-%d")
#                res[record.id]['year'] = str(date_end.year)
#                res[record.id]['month'] = str(date_end.month)
#        return res
#
#    def _invoice(self, cr, uid, ids, field_name, arg, context={}):
#        res = {}
#        records = self.browse(cr, uid, ids, context)
#        for record in records :
#            res[record.id] = {
#                'invoiced' : False,
#            }
#            if record.type == 'family':
#                if record.invoice_id and record.invoice_id.state not in ['draft','cancel']:
#                    res[record.id]['invoiced'] = True
#                else:
#                    invoice_obj = self.pool.get('account.invoice')
#                    invoice_ids = invoice_obj.search(cr, uid, [
#                                                               ('partner_id','=', record.family_id.id),
#                                                               ('date_begin', '=', record.date_begin),
#                                                               ('date_end', '=', record.date_end),
#                                                               ])
#                    if invoice_ids:
#                        invoice_data = invoice_obj.browse(cr, uid, invoice_ids)
#                        for inv in invoice_data:
#                            if inv.state in ['open','paid']:
#                                res[record.id]['invoiced'] = True
#                                break
#        return res
#    
#    _columns = {
#        'name': fields.function(_name_user, method=True, type='char', size=64, string='Period', store=True, multi=True),
#        'employee_id': fields.many2one('hr.employee', 'Employee'),
#        'partner_id': fields.many2one('res.partner', 'Partner'),#family_id
#        'date_begin': fields.date('Begin', required=True),
#        'date_end': fields.date('End', required=True),
#        'date_validated': fields.date('Validation date', readonly=True),
#        'state': fields.selection([('draft','Draft'),('validated','Validated')], 'State', readonly=True),
#        'type': fields.selection([('employee','Employee'),('partner','Partner')], 'Type'),
#        'partner_service_ids': fields.one2many('service.job', 'partner_period_id', 'Parnter Service'),#family_service_ids
#        'employee_service_ids': fields.one2many('service.job', 'employee_period_id', 'Employee Service'),
#        # TODO: Move this to specific module
##        'validated_hours' : fields.float('Validated hours'),
##        'modified_hours' : fields.float('Modified hours from invoicing'),
##        'diff_hours_manda' : fields.float('Current period adjustment'),
##        'modified_hours_manda' : fields.float('Previous period adjustment'),
##        'period_type': fields.selection([('other','Other'),('previous','Previous Period'),('current','Current Period'),('next','Next Period')], 'Category', readonly=True),
#        'month' : fields.function(_get_date, method=True, multi='all', string="Month", type="selection",
#                        selection=[('1','January'), ('2','February'), ('3','March'), ('4','April'),
#                                   ('5','May'), ('6','June'), ('7','July'), ('8','August'), ('9','September'),
#                                   ('10','October'), ('11','November'), ('12','December')],
#                        store=True),
#        'year' : fields.function(_get_date, method=True, multi='all', type="char", size=4, store=True, string="Year"),
#        'invoiced' : fields.function(_invoice, method=True, type='boolean', string='Invoiced', multi='invoiced', store=True),
#        'invoice_id' : fields.many2one('account.invoice', 'Invoice', readonly=True),
#    }
#    
#    _defaults = {
#        'state' : lambda *a: 'draft',
#    }
#    _sql_constraints = [
#        ('unique_employee_month', 'unique (employee_id,year,month)', 'The period must be unique for the employee.'),
#        ('unique_partner_month', 'unique (partner_id,year,month)', 'The period must be unique for the partner.'),
#    ]
#
#service_period()

class service_state(osv.osv):
    _name = 'service.state'
    _description = 'Service state'
    _columns = {
        'name': fields.char('Name', required=True, size=46, translate=True),
        'to_invoice': fields.many2one('hr_timesheet_invoice.factor', 'Invoice on Timesheet & Costs'),
        'type': fields.selection([('presence','Presence'),('absence','Absence')], 'Type', required=True),
#        'auto': fields.boolean('Auto'),
        'holiday_status_id': fields.many2one('hr.holidays.status', 'Leave Type'),
#        'code': fields.char('Code', required=True, size=18),
    }
    
    _defaults = {
        'type': lambda *a: 'presence',
    }
#    _order = 'code'
service_state()

#class service_job(osv.osv):
#    _name = "service.job"
#    _description = "Service job"
#
#    def _compute_duration(self, cr, uid, ids, field_name, arg, context):
#        """on retourne la difference entre date de fin et de depart, avec les convertions de type qui s imposent"""
#        res = {}
#        for service in self.browse(cr, uid, ids):
#            diff = (DateTime.strptime(service.date_end,'%Y-%m-%d %H:%M:%S') - DateTime.strptime(service.date_start,'%Y-%m-%d %H:%M:%S')) 
#            res[service.id] = diff.hours
#        return res
#
##    """The first time a childcare is saved, the date is saved. It can't be changed.
##    #### Modification V2: the childcare may be copy, then put in an other day, the time_start change and the day memory change too"""
##    def _memory_day(self, cr, uid, ids, field_name, arg, context):
##        res = {}
##        for job in self.browse(cr, uid, ids) :
##            res[job.id] = job.date_start.split(' ')[0]
##        return res
#                
#    """Checks that the service job begins and ends the same day, and that start hour is lower than end hour"""
#    def _same_day(self, cr, uid, ids):
#        for job in self.browse(cr, uid, ids):
#            if job.date_end.split(' ')[0] != job.date_start.split(' ')[0] or job.date_end <= job.date_start:
#                return False
#        return True
#
#    def _period(self, cr, uid, date, field_name, invoice_day=1, context=None):
#        if context is None:
#            context = {}
#        year,month,day = map(int,date.split('-'))
#        if field_name == 'begin':
#            if day <= 20:
#                if month == 1:
#                    month = 12
#                    year = year - 1
#                else:
#                    month = month - 1
#            day = 21
#            res = datetime.date(year, month, day)
#        if field_name == 'end':
#            if day > 20:
#                if month == 12:
#                    month = 1
#                    year = year + 1
#                else:
#                    month = month + 1
#            day = 20
#            res = datetime.date(year, month, day)
#        return res
#    
#    """As Employees and Partners should have only one period by month
#    This function get automatically the associate periods for this service or create if dont exist yet"""
#    def get_period(self, cr, uid, vals, context=None):
#        day = str(vals['date_start'])[0:10]
#        invoice_day = 21
#        contract_id = vals.get('contract_id')
#        partner = False
#        if contract_id:
#            contract = self.pool.get('contract.contract').browse(cr, uid, contract_id, context=context)
#            partner = contract and contract.partner_id and contract.partner_id.id or False
#        employee_contract_id = vals.get('employee_contract_id')
#        employee = False
#        if employee_contract_id:
#            employee_contract = self.pool.get('hr.contract').browse(cr, uid, employee_contract_id, context=context)
#            employee = employee_contract and employee_contract.employee_id and employee_contract.employee_id.id or False
#        period_obj = self.pool.get('service.period')
#        partner_period_ids = period_obj.search(cr, uid, [
#                                             ('date_begin','<=',day),
#                                             ('date_end','>=',day),
#                                             ('partner_id','=',partner),
#                                             ])
#        if partner_period_ids:
#            vals.update({'partner_period_id': partner_period_ids[0]})
#        else:
#            begin_period = self._period(cr, uid, day, 'begin', invoice_day, context)
#            end_period = self._period(cr, uid, day, 'end', invoice_day, context)
#            id = period_obj.create(cr, uid, {'date_begin': begin_period, 'date_end': end_period, 'partner_id': partner, 'type': 'partner'}, context={'date_begin': begin_period})
#            vals.update({'partner_period_id': id})
#        
#        employee_period_ids = period_obj.search(cr, uid, [
#                                             ('date_begin','<=',day),
#                                             ('date_end','>=',day),
#                                             ('employee_id','=',employee),
#                                             ])
#        if employee_period_ids:
#            vals.update({'employee_period_id': employee_period_ids[0]})
#        else:
#            begin_period = self._period(cr, uid, day, 'begin', invoice_day, context)
#            end_period = self._period(cr, uid, day, 'end', invoice_day, context)
#            id = period_obj.create(cr, uid, {'date_begin': begin_period, 'date_end': end_period, 'employee_id': employee, 'type': 'employee'}, context={'date_begin': begin_period})
#            vals.update({'employee_period_id': id})
#        return vals
#
#    _columns = {
#        'employee_contract_id': fields.many2one('hr.contract', 'Work Contract'),
#        'contract_id': fields.many2one('contract.contract', 'Partner Contract'),
#        'employee_id': fields.related('employee_contract_id', 'employee_id', string='Employee', type='many2one', relation='hr.employee', readonly=True, store=True),
#        'partner_id': fields.related('contract_id', 'partner_id', string='Partner', type='many2one', relation='res.partner', readonly=True, store=True),
#        'date_start': fields.datetime('Begin date', required=True),
#        'date_end': fields.datetime('End date', required=True),
#        'duration': fields.function(_compute_duration, method=True, type='float', string='Duration', store=True),
#        'duration_validated': fields.float('Validated and invoiced duration', readonly=True),
#        'responsible_hour': fields.float('Responsible Duration'),
#        'responsible_hour_val': fields.float('Validated and invoiced responsible duration', readonly=True),
#        'state': fields.many2one('service.state', 'State', required=True),
#        'state_validated': fields.many2one('service.state', 'State validated', readonly=True),
#        'validation_partner': fields.char('Partner Validation', size=128, readonly=True, translate=True),#validation_family
#        'validation_employee': fields.char('Employee Validation', size=128, readonly=True, translate=True),
#        'partner_period_id': fields.many2one('service.period', 'Partner period'),#family_period_id
#        'employee_period_id': fields.many2one('service.period', 'Employee period'),
#        'company_id': fields.many2one('res.company', 'Company'),
#    }
#
#    _defaults = {
#         'validation_partner': lambda *a: _('Not validated yet'),
#         'validation_employee': lambda *a: _('Not validated yet'),
#         'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'service.job', context=c),
#    }
#    
#    _order = 'employee_id, date_start'    
#    _constraints = [
#        (_same_day, 'The service job should begins and ends the same day, and the start hour should be lower than end hour', ['date_start','date_end'])
#    ]
#
#    """It's checking employee and partner periods and write the right ones in or create missing. Then create the child care"""
#    def create(self, cr, uid, vals, context=None):
#        vals = self.get_period(cr, uid, vals, context)
#        return super(service_job, self).create(cr, uid, vals, context)
#
#    def validate_partner(self, cr, uid, ids, context=None):
#        if context is None:
#            context = {}
#        now = datetime.datetime.now()
#        partner_obj = self.pool.get('res.partner')
#        period_obj = self.pool.get('service.period')
#        if ids:
#            vals = {}
#            if partner_obj.search(cr, uid, [('partner_user_id', '=', uid)]):
#                """It's possible to validate again the service job"""
#                vals = {'validation_partner' : now.strftime('%d/%m/%y')}
#                self.write(cr, uid, ids, vals, context)
#        return True
#    
#    def validate_employee(self, cr, uid, ids, context=None):
#        if context is None:
#            context = {}
#        now = datetime.datetime.now()
#        employee_obj = self.pool.get('hr.employee')
#        period_obj = self.pool.get('service.period')
#        if ids:
#            vals = {}
#            if employee_obj.search(cr, uid, [('user_id', '=', uid)]) :
#                vals = {'validation_employee' : now.strftime('%d/%m/%y')}
#                self.write(cr, uid, ids, vals, context)
#        return True
#
#service_job()
class hr_timesheet_sheet(osv.osv):
    _inherit = "hr_timesheet_sheet.sheet"
    
    def _total_attendances(self, cr, uid, ids, name, args, context=None):
        """ Get the total attendance for the timesheets
            Returns a dict like :
                {id: {'date_current': '2011-06-17',
                      'total_per_day': {day: timedelta, ...},
                     },
                 ...
                }
        """
        context = context or {}
#        attendance_obj = self.pool.get('hr.attendance')
        sheet_line_obj = self.pool.get('hr.analytic.timesheet')
        res = {}
        for sheet_id in ids:
            sheet = self.browse(cr, uid, sheet_id, context=context)
            date_current = sheet.date_current
            # field attendances_ids of hr_timesheet_sheet.sheet only
            # returns attendances of timesheet's current date
#            attendance_ids = attendance_obj.search(cr, uid, [('sheet_id', '=', sheet_id)], context=context)
#            attendances = attendance_obj.browse(cr, uid, attendance_ids, context=context)
#            total_attendance = {}
#            for attendance in [att for att in attendances
#                               if att.action in ('sign_in', 'sign_out')]:
#                day = attendance.name[:10]            sheet_lines_ids = sheet_line_obj.search(cr, uid, ['|',('sheet_id', '=', sheet_id),('partner_sheet_id', '=', sheet_id)], context=context)
            total_attendance = {}
            sheet_lines_ids = sheet_line_obj.search(cr, uid, ['|',('sheet_id', '=', sheet_id),('partner_sheet_id', '=', sheet_id)], context=context)
            sheet_lines = sheet_line_obj.browse(cr, uid, sheet_lines_ids, context=context)

            for line in sheet_lines:
                day = line.date
                if not total_attendance.get(day, False):
                    total_attendance[day] = []
                total_attendance[day].append(line)
            total_attendance = sheet_line_obj.compute_total_attendance(cr, uid, total_attendance, context=context)
#            for day in total_attendance.keys():
#                if total_attendance[day] == []:
#                    total_attendance[day] = timedelta(seconds=0)
#                elif len(total_attendance[day]) == 1:
#                    line = total_attendance[day][0]
#                    if line.state_id and line.state_id.type == 'presence':
#                        total_attendance[day] = timedelta(hours=line.unit_amount)
#                    else:
#                        total_attendance[day] = timedelta(seconds=0)
#                else:
#                    lines = sorted(total_attendance[day], key=lambda a: (a.date_start,a.date_end))
#                    total_attendance[day] = timedelta(seconds=0)
#                    date_start = False
#                    date_end = False
#                    for line in lines:
#                        if line.state_id and line.state_id.type == 'presence':
#                            if line.date_start:
#                                if not date_start or line.date_start < date_start:
#                                    date_start = line.date_start
#                                if not date_end:
#                                    date_end = line.usual_date_end
#                                    continue
#                                if line.date_end > date_end:
#                                    if date_end > line.date_start:
#                                        date_end = line.date_end
#                                    else:
#                                        diff = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00')
#                                        total_attendance[day] += timedelta(seconds=diff.seconds)
#                                        date_start = line.date_start
#                                        date_end = line.date_end
#                    if date_start and date_end:
#                        diff = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00')
#                        total_attendance[day] += timedelta(seconds=diff.seconds)
            res[sheet_id] = total_attendance

#                attendance_in_time = datetime.datetime.strptime(attendance.name, '%Y-%m-%d %H:%M:%S')
#                attendance_interval = timedelta(hours=attendance_in_time.hour,
#                                                minutes=attendance_in_time.minute,
#                                                seconds=attendance_in_time.second)
#                if attendance.action == 'sign_in':
#                    total_attendance[day] -= attendance_interval
#                else:
#                    total_attendance[day] += attendance_interval
#
#                # if the delta is negative, it means that a sign out is missing
#                # in a such case, we want to have the time to the end of the day
#                # for a past date, and the time to now for the current date
#                if total_attendance[day] < timedelta(0):
#                    if day == date_current:
#                        now = datetime.datetime.now()
#                        total_attendance[day] += timedelta(hours=now.hour,
#                                                           minutes=now.minute,
#                                                           seconds=now.second)
#                    else:
#                        total_attendance[day] += timedelta(days=1)

            res[sheet_id] = {
                'date_current': date_current,
                'total_per_day': total_attendance
            }
        return res

    def _total_timesheet(self, cr, uid, ids, name, args, context=None):
        """ Get the total of analytic lines for the timesheets
            Returns a dict like :
                {id: {day: timedelta, ...}}
        """
        context = context or {}
        sheet_line_obj = self.pool.get('hr.analytic.timesheet')

        res = {}
        for sheet_id in ids:
            # field timesheet_ids of hr_timesheet_sheet.sheet only
            # returns lines of timesheet's current date
            sheet_lines_ids = sheet_line_obj.search(cr, uid, ['|',('sheet_id', '=', sheet_id),('partner_sheet_id', '=', sheet_id)], context=context)
            sheet_lines = sheet_line_obj.browse(cr, uid, sheet_lines_ids, context=context)
            total_timesheet = {}
            for line in sheet_lines:
                day = line.date
                if not total_timesheet.get(day, False):
                    total_timesheet[day] = []
                total_timesheet[day].append(line)
            total_timesheet = sheet_line_obj.compute_total_timesheet(cr, uid, total_timesheet, context=context)
#            for day in total_timesheet.keys():
#                if total_timesheet[day] == []:
#                    total_timesheet[day] = timedelta(seconds=0)
#                elif len(total_timesheet[day]) == 1:
#                    line = total_timesheet[day][0]
#                    total_timesheet[day] = timedelta(hours=line.unit_amount)
#                else:
#                    lines = sorted(total_timesheet[day], key=lambda a: (a.usual_date_start,a.usual_date_end))
#                    total_timesheet[day] = timedelta(seconds=0)
#                    date_start = False
#                    date_end = False
#                    for line in lines:
#                        if line.usual_date_start:
#                            if not date_start or line.usual_date_start < date_start:
#                                date_start = line.usual_date_start
#                            if not date_end:
#                                date_end = line.usual_date_end
#                                continue
#                            if line.usual_date_end > date_end:
#                                if date_end > line.usual_date_start:
#                                    date_end = line.usual_date_end
#                                else:
#                                    diff = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00')
#                                    total_timesheet[day] += timedelta(seconds=diff.seconds)
#                                    date_start = line.usual_date_start
#                                    date_end = line.usual_date_end
#                    if date_start and date_end:
#                        diff = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00')
#                        total_timesheet[day] += timedelta(seconds=diff.seconds)
            res[sheet_id] = total_timesheet
        return res

#    def _total(self, cr, uid, ids, name, args, context=None):
#        """ Compute the attendances, analytic lines timesheets and differences between them
#            for all the days of a timesheet and the current day
#        """
#        def sum_all_days(sheet_amounts):
#            print sheet_amounts
#            if not sheet_amounts:
#                return timedelta(seconds=0)
#            total = reduce(lambda memo, value: memo + value, sheet_amounts.values())
#            return total
#
#        def timedelta_to_hours(delta):
#            hours = 0.0
#            seconds = float(delta.seconds)
#            if delta.microseconds:
#                seconds += float(delta.microseconds) / 100000
#            hours += delta.days * 24
#            if seconds:
#                hours += seconds / 3600
#            return hours
#
#        res = {}
#        all_timesheet_attendances = self._total_attendances(cr, uid, ids, name, args, context=context)
#        all_timesheet_lines = self._total_timesheet(cr, uid, ids, name, args, context=context)
#        for id in ids:
#            res[id] = {}
#
#            all_attendances_sheet = all_timesheet_attendances[id]
#
#            date_current = all_attendances_sheet['date_current']
#            total_attendances_sheet = all_attendances_sheet['total_per_day']
#            total_attendances_all_days = sum_all_days(total_attendances_sheet)
#            total_attendances_day = total_attendances_sheet.get(date_current, timedelta(seconds=0))
#
#            total_timesheets_sheet = all_timesheet_lines[id]
#            total_timesheets_all_days = sum_all_days(total_timesheets_sheet)
#            total_timesheets_day = total_timesheets_sheet.get(date_current, timedelta(seconds=0))
#            total_difference_all_days = total_attendances_all_days - total_timesheets_all_days
#            total_difference_day = total_attendances_day - total_timesheets_day
#
#            res[id]['total_attendance'] = timedelta_to_hours(total_attendances_all_days)
#            res[id]['total_timesheet'] = timedelta_to_hours(total_timesheets_all_days)
#            res[id]['total_difference'] = timedelta_to_hours(total_difference_all_days)
#
#            res[id]['total_attendance_day'] = timedelta_to_hours(total_attendances_day)
#            res[id]['total_timesheet_day'] = timedelta_to_hours(total_timesheets_day)
#            res[id]['total_difference_day'] = timedelta_to_hours(total_difference_day)
#        return res
#    
#    _columns = {
#        'total_attendance_day': fields.function(_total, method=True, string='Total Attendance', multi="_total"),
#        'total_timesheet_day': fields.function(_total, method=True, string='Total Timesheet', multi="_total"),
#        'total_difference_day': fields.function(_total, method=True, string='Difference', multi="_total"),
#        'total_attendance': fields.function(_total, method=True, string='Total Attendance', multi="_total"),
#        'total_timesheet': fields.function(_total, method=True, string='Total Timesheet', multi="_total"),
#        'total_difference': fields.function(_total, method=True, string='Difference', multi="_total"),
#    }

    def _get_invoice_ids(self, cr, uid, ids, field_name, arg, context={}):
        result = {}
        for record in self.browse(cr, uid, ids, context):
            result[record.id] = []
            for x in record.employee_line_ids:
                if x.invoice_id and x.invoice_id.id not in result[record.id]:
                    result[record.id].append(x.invoice_id.id)
        return result

    _columns = {
#        'period2_ids': fields.one2many('hr_timesheet_sheet.sheet.day2', 'sheet_id', 'Period', readonly=True),
#        'period3_ids': fields.one2many('hr_timesheet_sheet.sheet.day3', 'sheet_id', 'Period', readonly=True),
        'invoice_ids' : fields.function(_get_invoice_ids, method=True, type='many2many', relation="account.invoice", string="Related Invoices"),
        'employee_line_ids': fields.one2many('hr.analytic.timesheet', 'sheet_id', 'Lines', readonly=False),
    }
    
    def create_invoice(self, cr, uid, ids, context=None):
        return True
    
    def create_payslip(self, cr, uid, ids, context=None):
        return True

hr_timesheet_sheet()

class product_product(osv.osv):
    _inherit = 'product.product'
    
    def price_get(self, cr, uid, ids, ptype='list_price', context=None):
        if context is None:
            context = {}
        res = super(product_product, self).price_get(cr, uid, ids, ptype=ptype, context=context)
        if 'employee_contract' in context and context.get('employee_contract'):
            amount = self.pool.get('hr.contract').browse(cr, uid, context['employee_contract'], context=context).wage or False
            if amount:
                for product in self.browse(cr, uid, ids, context=context):
                    res[product.id] = amount
        return res

product_product()

class account_analytic_line(osv.osv):
    _inherit = 'account.analytic.line'
    
    def _compute_duration(self, cr, uid, ids, field_name, arg, context):
        res = {}
        for service in self.browse(cr, uid, ids):
            diff = False
            if service.usual_date_end and service.usual_date_start:
                diff = (DateTime.strptime(service.usual_date_end,'%Y-%m-%d %H:%M:%S') - DateTime.strptime(service.usual_date_start,'%Y-%m-%d %H:%M:%S'))
            res[service.id] = diff and diff.hours or 0.0
        return res
    
    def _get_difference_hours(self, cr, uid, ids, name, args, context=None):
        res = {}
        timesheet_obj = self.pool.get('hr.analytic.timesheet')
        for line in self.browse(cr, uid, ids, context=context):
            res[line.id] = {
                'difference': line.unit_amount - (line.duration or 0.0),
            }
        return res
    
    _columns = {
        'usual_date_start': fields.datetime('Usual Begin date', readonly=True),
        'usual_date_end': fields.datetime('Usual End date', readonly=True),
        'usual_state_id': fields.many2one('service.state', 'Usual State', readonly=True),
        'employee_contract_id': fields.many2one('hr.contract', 'Work Contract'),
        'employee_id': fields.many2one('hr.employee', 'Employee'),
        'contract_id': fields.many2one('contract.contract', 'Partner Contract'),
        'duration': fields.function(_compute_duration, method=True, type='float', string='Duration', store=True),
        'difference': fields.function(_get_difference_hours, method=True, string='Difference', type='float', multi='all'),
    }
    
#    def on_change_unit_amount(self, cr, uid, id, prod_id, quantity, company_id,
#            unit=False, journal_id=False, employee_contract_id=False, context=None):
#        if context==None:
#            context={}
#        print 'here I am'
#        return super(account_analytic_line, self).on_change_unit_amount(cr, uid, id, prod_id, quantity, company_id, unit=unit, journal_id=journal_id, context=context)
    
account_analytic_line()

class hr_analytic_timesheet(osv.osv):
    _inherit = 'hr.analytic.timesheet'
    
    def _period(self, cr, uid, date, field_name, invoice_day=1, context=None):
        if context is None:
            context = {}
        if not isinstance(date, str):
            date = str(date)
        year,month,day = map(int,date.split(' ')[0].split('-'))
        if field_name == 'begin':
            if day <= 20:
                if month == 1:
                    month = 12
                    year = year - 1
                else:
                    month = month - 1
            day = 21
            res = datetime.date(year, month, day)
        if field_name == 'end':
            if day > 20:
                if month == 12:
                    month = 1
                    year = year + 1
                else:
                    month = month + 1
            day = 20
            res = datetime.date(year, month, day)
        return res
    
    def get_create_sheet(self, cr, uid, date, employee_id, context=None):
        sheet_obj = self.pool.get('hr_timesheet_sheet.sheet')
        user_id = self.pool.get('hr.employee').browse(cr, uid, employee_id, context=context).user_id
        sheet_id = False
        sheet_ids = sheet_obj.search(cr, uid,
            [('date_to', '>=', date), ('date_from', '<=', date),
                 ('employee_id.user_id', '=', user_id.id)],
                context=context)
        if not sheet_ids:
            end = self._period(cr, uid, date, field_name='end', invoice_day=21, context=context)
            begin = self._period(cr, uid, date, field_name='begin', invoice_day=21, context=context)
            name = datetime.datetime.strftime(end,'%m/%Y')
            vals = {'employee_id': employee_id, 'date_from': begin, 'date_to': end, 'date_current': begin, 'name': name}
            sheet_id = sheet_obj.create(cr, uid, vals, context=context)
        return sheet_ids and sheet_ids[0] or sheet_id

#    def _holidays(self, cr, uid, ids, context=None):
#        if context == None:
#            context = {}
#        return False
#    
#    def _presence(self, cr, uid, ids, context=None):
#        if context == None:
#            context = {}
#        return False
#    
#    def _change_sheet_state(self, cr, uid, ids, vals, previous_state=False, next_state=False, context=None):
#        if context == None:
#            context = {}
#        return False
    
    _columns = {
        'state_id': fields.many2one('service.state', 'State', required=True),
        'state': fields.selection([('draft','Draft'),('validated','Validated')], 'State', required=True, readonly=True),
        'holiday_id': fields.many2one('hr.holidays', 'Holiday'),
        'date_start': fields.datetime('Begin date', required=True),
        'date_end': fields.datetime('End date', required=True),
        'state_type': fields.related('state_id', 'type', type='selection', selection=[('presence','Presence'),('absence','Absence')], string='State type', readonly=True),
    }
    
    _defaults = {
        'state': lambda *a: 'draft',
    }
    
    def on_change_date_duration(self, cr, uid, id, date_start=False, date_end=False, employee_contract_id=False, context=None):
        if context == None:
            context = {}
        res = {}
        if date_start and date_end:
            res['value'] = {}
            diff = (DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00'))
            res['value']['unit_amount'] = diff.seconds / 3600
            if employee_contract_id:
                context.update({'employee_contract':employee_contract_id})
                res['context'] = context
        return res
    
    def on_change_unit_amount2(self, cr, uid, id, prod_id, unit_amount, company_id, unit=False, journal_id=False, employee_contract_id=False, context=None):
        if context == None:
            context = {}
        if employee_contract_id:
            context['employee_contract'] = employee_contract_id
        return super(hr_analytic_timesheet, self).on_change_unit_amount(cr, uid, id, prod_id, unit_amount, company_id, unit=unit, journal_id=journal_id, context=context)
    
    def copy(self, cr, uid, id, default=None, context=None):
        if not default:
            default = {}
        default['usual_date_start'] = False
        default['usual_date_end'] = False
        default['holiday_id'] = False
        default['state'] = 'draft'
        return super(hr_analytic_timesheet, self).copy(cr, uid, id, default=default, context=context)
    
    def create(self, cr, uid, vals, context=None):
        date_end = vals.get('date_end')
        date_start = vals.get('date_start')
        if date_start or date_end:
            vals['date'] = date_start or date_end or vals.get('date')
        if not vals.get('employee_id'):
            employee_id = False
            if vals.get('contract_id'):
                contract = self.pool.get('hr.contract').read(cr, uid, vals.get('contract_id'), ['employee_id'], context=context)
                employee_id = contract['employee_id'] and contract['employee_id'][0] or False
            if not employee_id and vals.get('user_id'):
                employee_ids = self.pool.get('hr.employee').search(cr, uid, [('user_id', '=', vals.get('user_id'))], context=context)
                if employee_ids:
                    employee_id = employee_ids[0]
            vals['employee_id'] = employee_id
        if vals.get('date') and vals.get('employee_id'):
            vals['sheet_id'] = self.get_create_sheet(cr, uid, vals.get('date'), vals.get('employee_id'), context=context)
#        if vals.get('state_id'):
#            self._change_sheet_state(cr, uid, [], vals, previous_state=False, next_state=vals.get('state'), context=context)
        return super(hr_analytic_timesheet, self).create(cr, uid, vals, context=context)
    
    def write(self, cr, uid, ids, vals, context=None):
        if isinstance(ids, (long, int)):
            ids = [ids]
        if context == None:
            context = {}
        current_data = self.browse(cr, uid, ids, context=context)
        date_end = vals.get('date_end')
        date_start = vals.get('date_start')
        for current in current_data:
            if date_start and not date_end:
                date_end = current.date_end
            if date_end and not date_start:
                date_start = current.date_start
            if date_end and date_start:
                date_end = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:%S')
                date_end = date_end - timedelta(seconds=date_end.second)
                if vals.get('date_end'):
                    vals['date_end'] = date_end
                date_start = DateTime.strptime(date_start,'%Y-%m-%d %H:%M:%S')
                date_start = date_start - timedelta(seconds=date_start.second)
                if vals.get('date_start'):
                    vals['date_start'] = date_start
                diff = (date_end - date_start)
                unit_amount = diff.hours
                vals['unit_amount'] = unit_amount
                if not vals.get('amount'):
                    product_id = vals.get('product_id', False)
                    if not product_id:
                        product_id = current.product_id and current.product_id.id or False
                    journal_id = vals.get('journal_id', False)
                    if not journal_id:
                        journal_id = current.journal_id and current.journal_id.id or False
    #                timesheet_obj = self.pool.get('hr.analytic.timesheet')
                    context['employee_contract'] = current.employee_contract_id.id or False
                    res = self.on_change_unit_amount(cr, uid, id=False, prod_id=product_id, unit_amount=unit_amount, company_id=False, unit=False, journal_id=journal_id, context=context)
                    if res.get('value'):
                        if res['value'].get('amount'):
                            vals.update({'amount': res['value'].get('amount', 0)})
            vals['date'] = date_start or current.date
            employee_id = vals.get('employee_id') or current.employee_id.id
            if employee_id:
                vals['sheet_id'] = self.get_create_sheet(cr, uid, vals.get('date'), employee_id, context=context)
            super(hr_analytic_timesheet, self).write(cr, uid, [current.id], vals, context=context)
        return True
    
    def validate_timesheet(self, cr, uid, ids, context=None):
        if context == None:
            context = {}
        if not isinstance(ids, list):
            ids = [ids]
        
#        attendance_obj = self.pool.get('hr.attendance')
        holiday_obj = self.pool.get('hr.holidays')
        validation_obj = self.pool.get('hr.timesheet.validation')
        
        timesheet_ids = self.browse(cr, uid, ids, context=context)
        for timesheet in timesheet_ids:
            vals = {'state':'validated'}
            state = timesheet.state_id
#            if state and state.type == 'presence':
#                vals = {
#                    'employee_id': timesheet.employee_id.id,
#                    'sheet_id': timesheet.sheet_id and timesheet.sheet_id.id or False,
#                }
#                sign_in = sign_out = vals
#                sign_in.update({
#                    'action': 'sign_in',
#                    'name': timesheet.date_start,
#                })
##                attendance_obj.create(cr, uid, sign_in, context=context)
#                sign_out.update({
#                    'action': 'sign_out',
#                    'name': timesheet.date_end,
#                })
##                attendance_obj.create(cr, uid, sign_out, context=context)
            if state and state.type == 'absence' and timesheet.usual_date_start:
                holiday_vals = self.get_holiday_vals(cr, uid, timesheet.id, context=context)
                if not timesheet.holiday_id:
                    holiday_id = holiday_obj.create(cr, uid, holiday_vals, context=context)
                else:
                    holiday_obj.write(cr, uid, timesheet.holiday_id.id, holiday_vals, context=context)
                    holiday_id = timesheet.holiday_id.id
                vals.update({'holiday_id': holiday_id})
            else:
                if timesheet.holiday_id:
                    holiday_obj.unlink(cr, uid, [timesheet.holiday_id.id], context=context)
            timesheet_vals = self.get_timesheet_vals(cr, uid, timesheet.id, context=context)
            timesheet_vals.update(vals)
            validation_obj.create(cr, uid, {'timesheet_id':timesheet.id}, context=context)
            self.write(cr, uid, timesheet.id, timesheet_vals, context=context)
        return True

    def draft_timesheet(self, cr, uid, ids, context=None):
        if context == None:
            context = {}
        if not isinstance(ids, list):
            ids = [ids]
        self.write(cr, uid, ids, {'state':'draft'}, context=context)
        return True
    
    def get_timesheet_vals(self, cr, uid, id, context=None):
        timesheet_vals = {}
        timesheet = self.browse(cr, uid, id, context=context)
        timesheet_vals.update({'to_invoice': timesheet.state_id.to_invoice and timesheet.state_id.to_invoice.id or False})
        return timesheet_vals
    
    def get_holiday_vals(self, cr, uid, id, context=None):
        timesheet = self.browse(cr, uid, id, context=context)
        vals = {
            'holiday_type': 'employee',
            'employee_id': timesheet.employee_id.id,
            'name': timesheet.state_id.holiday_status_id and timesheet.state_id.holiday_status_id.name or False,
            'holiday_status_id': timesheet.state_id.holiday_status_id and timesheet.state_id.holiday_status_id.id or False,
            'date_to': timesheet.usual_date_end,
            'date_from': timesheet.usual_date_start,
            'number_of_days_temp': 1,
        }
        return vals
    
    def compute_total_timesheet(self, cr, uid, total_timesheet, context=None):
        for day in total_timesheet.keys():
            if total_timesheet[day] == []:
                total_timesheet[day] = timedelta(seconds=0)
            elif len(total_timesheet[day]) == 1:
                line = total_timesheet[day][0]
                total_timesheet[day] = timedelta(hours=line.unit_amount)
            else:
                lines = sorted(total_timesheet[day], key=lambda a: (a.usual_date_start,a.usual_date_end))
                total_timesheet[day] = timedelta(seconds=0)
                date_start = False
                date_end = False
                for line in lines:
                    if line.usual_date_start:
                        if not date_start or line.usual_date_start < date_start:
                            date_start = line.usual_date_start
                        if not date_end:
                            date_end = line.usual_date_end
                            continue
                        if line.usual_date_end > date_end:
                            if date_end > line.usual_date_start:
                                date_end = line.usual_date_end
                            else:
                                diff = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00')
                                total_timesheet[day] += timedelta(seconds=diff.seconds)
                                date_start = line.usual_date_start
                                date_end = line.usual_date_end
                if date_start and date_end:
                    diff = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00')
                    total_timesheet[day] += timedelta(seconds=diff.seconds)
        return total_timesheet
    
    def compute_total_attendance(self, cr, uid, total_attendance, context=None):
        for day in total_attendance.keys():
            if total_attendance[day] == []:
                total_attendance[day] = timedelta(seconds=0)
            elif len(total_attendance[day]) == 1:
                line = total_attendance[day][0]
                if line.state_id and line.state_id.type == 'presence':
                    total_attendance[day] = timedelta(hours=line.unit_amount)
                else:
                    total_attendance[day] = timedelta(seconds=0)
            else:
                lines = sorted(total_attendance[day], key=lambda a: (a.date_start,a.date_end))
                total_attendance[day] = timedelta(seconds=0)
                date_start = False
                date_end = False
                for line in lines:
                    if line.state_id and line.state_id.type == 'presence':
                        if line.date_start:
                            if not date_start or line.date_start < date_start:
                                date_start = line.date_start
                            if not date_end:
                                date_end = line.usual_date_end
                                continue
                            if line.date_end > date_end:
                                if date_end > line.date_start:
                                    date_end = line.date_end
                                else:
                                    diff = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00')
                                    total_attendance[day] += timedelta(seconds=diff.seconds)
                                    date_start = line.date_start
                                    date_end = line.date_end
                if date_start and date_end:
                    diff = DateTime.strptime(date_end,'%Y-%m-%d %H:%M:00') - DateTime.strptime(date_start,'%Y-%m-%d %H:%M:00')
                    total_attendance[day] += timedelta(seconds=diff.seconds)
        return total_attendance

hr_analytic_timesheet()

class res_company(osv.osv):
    _inherit = "res.company"
    _columns = {
        'service_invoice_day': fields.integer('Service Invoice Day'),
    }
    
res_company()

class hr_employee(osv.osv):
    
    _inherit = "hr.employee"
    _columns = {
#        'service_jobs_ids': fields.one2many('service.job', 'employee_id', 'Service Jobs'),
        'sheet_ids': fields.one2many('hr_timesheet_sheet.sheet', 'employee_id', 'Periods'),
    }
    
    def copy(self, cr, uid, id, default=None, context=None):
        if default == None:
            default = {}
        default['sheet_ids'] = []
        return super(hr_employee, self).copy(cr, uid, id , default=default, context=context)
    
hr_employee()

#class hr_timesheet_sheet_sheet_day2(osv.osv):
#    _name = "hr_timesheet_sheet.sheet.day2"
#    _description = "Timesheets by Period"
#    _auto = False
#    _order='name'
#    
#    def _total_timesheet(self, cr, uid, ids, name, args, context=None):
#        """ Get the total of analytic lines for the timesheets
#            Returns a dict like :
#                {id: {day: timedelta, ...}}
#        """
#        context = context or {}
#        sheet_line_obj = self.pool.get('hr.analytic.timesheet')
#
#        res = {}
#        for current_data in self.browse(cr, uid, ids, context=context):
#            sheet_lines_ids = sheet_line_obj.search(cr, uid, [
#                                        ('sheet_id', '=', current_data.sheet_id.id),
#                                        ('usual_date_start','<=',current_data.name),
#                                        ('usual_date_end','>=',current_data.name)], context=context)
#            sheet_lines = sheet_line_obj.browse(cr, uid, sheet_lines_ids, context=context)
#            total_timesheet = {}
#            for line in sheet_lines:
#                day = line.date
#                if not total_timesheet.get(day, False):
#                    total_timesheet[day] = []
#                total_timesheet[day].append(line)
#            total_timesheet = sheet_line_obj.compute_total_timesheet(cr, uid, total_timesheet, context=context)
#            res[current_data.id] = {'total_timesheet':total_timesheet[day].seconds / 3600}
#        return res
#    
#    def _total_attendance(self, cr, uid, ids, name, args, context=None):
#        """ Get the total attendance for the timesheets
#            Returns a dict like :
#                {id: {'date_current': '2011-06-17',
#                      'total_per_day': {day: timedelta, ...},
#                     },
#                 ...
#                }
#        """
#        context = context or {}
#        sheet_line_obj = self.pool.get('hr.analytic.timesheet')
#        res = {}
#        for current_data in self.browse(cr, uid, ids, context=context):
#            total_attendance = {}
#            sheet_lines_ids = sheet_line_obj.search(cr, uid, [('sheet_id', '=', current_data.sheet_id.id),
#                                        ('date_start','<=',current_data.name),
#                                        ('date_end','>=',current_data.name)], context=context)
#            sheet_lines = sheet_line_obj.browse(cr, uid, sheet_lines_ids, context=context)
#
#            for line in sheet_lines:
#                day = line.date
#                if not total_attendance.get(day, False):
#                    total_attendance[day] = []
#                total_attendance[day].append(line)
#            total_attendance = sheet_line_obj.compute_total_attendance(cr, uid, total_attendance, context=context)
#            res[current_data.id] = {'total_attendance':total_attendance[day].seconds / 3600}
#        return res
#    
#    def _total_difference(self, cr, uid, ids, name, args, context=None):
#        context = context or {}
#        res = {}
#        for current_data in self.browse(cr, uid, ids, context=context):
#            res[current_data.id] = {'total_difference':(current_data.total_attendance or 0) - (current_data.total_timesheet or 0)}
#        return res
#    
#    _columns = {
#        'name': fields.date('Date', readonly=True),
#        'sheet_id': fields.many2one('hr_timesheet_sheet.sheet', 'Sheet', readonly=True, select="1"),
#        'total_timesheet': fields.function(_total_timesheet, method=True, string='Total Timesheet', multi="_total_timesheet", type='float' ),
#        'total_attendance': fields.function(_total_attendance, method=True, string='Total Attendance', multi="_total_attendance", type='float' ),
#        'total_difference': fields.function(_total_difference,  method=True, string='Difference', multi="_total_difference", type='float'),
#    }
#
#    def init(self, cr):
#        cr.execute("""create or replace view hr_timesheet_sheet_sheet_day2 as
#            SELECT max(hat.id) as id,
#                    aal.date as name,
#                    hat.sheet_id
#            FROM hr_analytic_timesheet hat, account_analytic_line aal
#            WHERE hat.line_id = aal.id
#            GROUP BY hat.sheet_id, aal.user_id, aal.date""")
#
#hr_timesheet_sheet_sheet_day2()

#class hr_timesheet_sheet_sheet_day3(osv.osv):
#    _name = "hr_timesheet_sheet.sheet.day3"
#    _description = "Timesheets by Period"
#    _auto = False
#    _order='name'
#    
#    def _total_timesheet(self, cr, uid, ids, name, args, context=None):
#        """ Get the total of analytic lines for the timesheets
#            Returns a dict like :
#                {id: {day: timedelta, ...}}
#        """
#        context = context or {}
#        sheet_line_obj = self.pool.get('hr.analytic.timesheet')
#
#        res = {}
#        for current_data in self.browse(cr, uid, ids, context=context):
#            sheet_lines_ids = sheet_line_obj.search(cr, uid, [
#                                        ('partner_sheet_id', '=', current_data.sheet_id.id),
#                                        ('usual_date_start','<=',current_data.name),
#                                        ('usual_date_end','>=',current_data.name)], context=context)
#            sheet_lines = sheet_line_obj.browse(cr, uid, sheet_lines_ids, context=context)
#            total_timesheet = {}
#            for line in sheet_lines:
#                day = line.date
#                if not total_timesheet.get(day, False):
#                    total_timesheet[day] = []
#                total_timesheet[day].append(line)
#            total_timesheet = sheet_line_obj.compute_total_timesheet(cr, uid, total_timesheet, context=context)
#            res[current_data.id] = {'total_timesheet':total_timesheet[day].seconds / 3600}
#        return res
#    
#    def _total_attendance(self, cr, uid, ids, name, args, context=None):
#        """ Get the total attendance for the timesheets
#            Returns a dict like :
#                {id: {'date_current': '2011-06-17',
#                      'total_per_day': {day: timedelta, ...},
#                     },
#                 ...
#                }
#        """
#        context = context or {}
#        sheet_line_obj = self.pool.get('hr.analytic.timesheet')
#        res = {}
#        for current_data in self.browse(cr, uid, ids, context=context):
#            total_attendance = {}
#            sheet_lines_ids = sheet_line_obj.search(cr, uid, [('partner_sheet_id', '=', current_data.sheet_id.id),
#                                        ('usual_date_start','<=',current_data.name),
#                                        ('usual_date_end','>=',current_data.name)], context=context)
#            sheet_lines = sheet_line_obj.browse(cr, uid, sheet_lines_ids, context=context)
#
#            for line in sheet_lines:
#                day = line.date
#                if not total_attendance.get(day, False):
#                    total_attendance[day] = []
#                total_attendance[day].append(line)
#            total_attendance = sheet_line_obj.compute_total_attendance(cr, uid, total_attendance, context=context)
#            res[current_data.id] = {'total_attendance':total_attendance[day].seconds / 3600}
#        return res
#    
#    def _total_difference(self, cr, uid, ids, name, args, context=None):
#        context = context or {}
#        res = {}
#        for current_data in self.browse(cr, uid, ids, context=context):
#            res[current_data.id] = {'total_difference':(current_data.total_attendance or 0) - (current_data.total_timesheet or 0)}
#        return res
#    
#    _columns = {
#        'name': fields.date('Date', readonly=True),
#        'sheet_id': fields.many2one('hr_timesheet_sheet.sheet', 'Sheet', readonly=True, select="1"),
#        'total_timesheet': fields.function(_total_timesheet, method=True, string='Timesheet', multi="_total_timesheet", type='float'),
#        'total_attendance': fields.function(_total_attendance, method=True, string='Attendance', multi="_total_attendance", type='float'),
#        'total_difference': fields.function(_total_difference,  method=True, string='Difference', multi="_total_difference", type='float'),
#    }
#
#    def init(self, cr):
#        cr.execute("""create or replace view hr_timesheet_sheet_sheet_day3 as
#            SELECT max(hat.id) as id,
#                    aal.date as name,
#                    hat.partner_sheet_id as sheet_id
#            FROM hr_analytic_timesheet hat, account_analytic_line aal
#            WHERE hat.line_id = aal.id
#            GROUP BY hat.partner_sheet_id, aal.user_id, aal.date""")
#
#hr_timesheet_sheet_sheet_day3()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
